SUMMARY = "Remote update GSRD customization"
DESCRIPTION = "Remote update GSRD lighttpd configuration customization to enable php and set home page"
AUTHOR = "Radu Bacrau <rbacrau@altera.com>"
SECTION = "remoteupdate"
LICENSE = "BSD-3-Clause"
LIC_FILES_CHKSUM="file://${COMMON_LICENSE_DIR}/BSD-3-Clause;md5=550794465ba0ec5312d6919e203a55f9"

inherit allarch
ALLOW_EMPTY_${PN} = "1"

DEPENDS = "altera-lighttpd-conf"

# Post process the lighttpd.conf file to enable fastcgi module and set home page
pkg_postinst_${PN}() {
#!/bin/sh
sed -ir 's:#\(.*mod_fastcgi\"\,\):\1:' $D/etc/lighttpd.conf
sed -ir 's:\(index-file.names *\=\).*\(,\):\1 ("\/cgi-bin\/index2.sh"\2:' $D/etc/lighttpd.conf
echo 'fastcgi.server = ( ".php" =>' >> $D/etc/lighttpd.conf
echo ' ( "localhost" =>' >> $D/etc/lighttpd.conf
echo '   (' >> $D/etc/lighttpd.conf
echo '     "socket" => "/tmp/php-fastcgi.socket",' >> $D/etc/lighttpd.conf
echo '     "bin-path" => "/usr/bin/php-cgi",' >> $D/etc/lighttpd.conf
echo '     "min-procs" => 2,' >> $D/etc/lighttpd.conf
echo '     "max-procs" => 4,' >> $D/etc/lighttpd.conf
echo '     "max-load-per-proc" => 8,' >> $D/etc/lighttpd.conf
echo '     "idle-timeout" => 50,' >> $D/etc/lighttpd.conf
echo '     "broken-scriptfilename" => "enable"' >> $D/etc/lighttpd.conf
echo '    )' >> $D/etc/lighttpd.conf
echo '   )' >> $D/etc/lighttpd.conf
echo ' )' >> $D/etc/lighttpd.conf
}

RDEPENDS_{PN} = "lighttpd-module-fastcgi"
