<?php
// mount sd card if necessary
if (!file_exists("/mnt/sdcard/ghrd_10as066n2.core.rbf")) {
    exec("mkdir -p /mnt/sdcard");
    exec("mount /dev/mmcblk0p1 /mnt/sdcard");
}

// read string from file
function read_string($filename) {
    if (file_exists($filename)) {
        return file_get_contents($filename, false, NULL, 0, 128);
    } else {
        return "n/a";
    }
}

// write string to file
function write_string($text, $filename) {
    if ($text) {
        $myfile = fopen($filename, "w");
        fwrite($myfile, $text);
        fclose($myfile);
    }
}

// currently running hardware and software filenames
$uboot_filename = "/mnt/sdcard/uboot";
$uboot_version_filename = "/mnt/sdcard/uboot.version";
$fpga_fabric_filename = "/mnt/sdcard/ghrd_10as066n2.core.rbf";
$fpga_fabric_version_filename = "/mnt/sdcard/ghrd_10as066n2.core.rbf.version";
$fpga_periph_filename = "/mnt/sdcard/ghrd_10as066n2.periph.rbf";
$fpga_periph_version_filename = "/mnt/sdcard/ghrd_10as066n2.periph.rbf.version";
$devicetree_filename = "/mnt/sdcard/socfpga_arria10_socdk.dtb";
$devicetree_version_filename = "/mnt/sdcard/socfpga_arria10_socdk.dtb.version";
$kernel_filename = "/mnt/sdcard/zImage";
$kernel_version_filename = "/mnt/sdcard/zImage.version";
$rootfs_version_filename = "/mnt/sdcard/rootfs.version";

// pending hardware and software filenames
$new_uboot_filename = "/mnt/sdcard/new_uboot";
$new_uboot_version_filename = "/mnt/sdcard/new_uboot.version";
$new_fpga_fabric_filename = "/mnt/sdcard/new_ghrd_10as066n2.core.rbf";
$new_fpga_fabric_version_filename = "/mnt/sdcard/new_ghrd_10as066n2.core.rbf.version";
$new_fpga_periph_filename = "/mnt/sdcard/new_ghrd_10as066n2.periph.rbf";
$new_fpga_periph_version_filename = "/mnt/sdcard/new_ghrd_10as066n2.periph.rbf.version";
$new_devicetree_filename = "/mnt/sdcard/new_socfpga_arria10_socdk.dtb";
$new_devicetree_version_filename = "/mnt/sdcard/new_socfpga_arria10_socdk.dtb.version";
$new_kernel_filename = "/mnt/sdcard/new_zImage";
$new_kernel_version_filename = "/mnt/sdcard/new_zImage.version";
$new_rootfs_filename = "/mnt/sdcard/rootfs-update.tgz";
$new_rootfs_version_filename = "/mnt/sdcard/new_rootfs.version";

// create the initial version files
if (!file_exists($uboot_version_filename)) {
	write_string("1.0", $uboot_version_filename);
}
if (!file_exists($fpga_fabric_version_filename)) {
	write_string("1.0", $fpga_fabric_version_filename);
}
if (!file_exists($fpga_periph_version_filename)) {
	write_string("1.0", $fpga_periph_version_filename);
}
if (!file_exists($devicetree_version_filename)) {
	write_string("1.0", $devicetree_version_filename);
}
if (!file_exists($kernel_version_filename)) {
	write_string("1.0", $kernel_version_filename);
}
if (!file_exists($rootfs_version_filename)) {
	write_string("1.0", $rootfs_version_filename);
}

if ($_POST["discard_button"]) {

    // discard updates if requested
    if (file_exists($new_uboot_filename)) {
        unlink($new_uboot_filename);
    }
    if (file_exists($new_uboot_version_filename)) {
        unlink($new_uboot_version_filename);
    }
    if (file_exists($new_fpga_fabric_filename)) {
        unlink($new_fpga_fabric_filename);
    }
    if (file_exists($new_fpga_fabric_version_filename)) {
        unlink($new_fpga_fabric_version_filename);
    }
    if (file_exists($new_fpga_periph_filename)) {
        unlink($new_fpga_periph_filename);
    }
    if (file_exists($new_fpga_periph_version_filename)) {
        unlink($new_fpga_periph_version_filename);
    }
    if (file_exists($new_devicetree_filename)) {
        unlink($new_devicetree_filename);
    }
    if (file_exists($new_devicetree_version_filename)) {
        unlink($new_devicetree_version_filename);
    }
    if (file_exists($new_kernel_filename)) {
        unlink($new_kernel_filename);
    }
    if (file_exists($new_kernel_version_filename)) {
        unlink($new_kernel_version_filename);
    }
    if (file_exists($new_rootfs_filename)) {
        unlink($new_rootfs_filename);
    }
    if (file_exists($new_rootfs_version_filename)) {
        unlink($new_rootfs_version_filename);
    }
} elseif ($_POST["upload_button"]) {

    // save the newly uploaded files and file versions    
    if ($_FILES["uboot_upfile"] && $_POST["uboot_check"]) {
        move_uploaded_file($_FILES["uboot_upfile"]["tmp_name"], $new_uboot_filename);
        write_string($_POST["uboot_version"], $new_uboot_version_filename);
    }
    if ($_FILES["fpga_fabric_upfile"] && $_POST["fpga_fabric_check"]) {
        move_uploaded_file($_FILES["fpga_fabric_upfile"]["tmp_name"], $new_fpga_fabric_filename);
        write_string($_POST["fpga_fabric_version"], $new_fpga_fabric_version_filename);
    }
    if ($_FILES["fpga_periph_upfile"] && $_POST["fpga_periph_check"]) {
        move_uploaded_file($_FILES["fpga_periph_upfile"]["tmp_name"], $new_fpga_periph_filename);
        write_string($_POST["fpga_periph_version"], $new_fpga_periph_version_filename);
    }
    if ($_FILES["kernel_upfile"] && $_POST["kernel_check"]) {
        move_uploaded_file($_FILES["kernel_upfile"]["tmp_name"], $new_kernel_filename);
        write_string($_POST["kernel_version"], $new_kernel_version_filename);
    }
    if ($_FILES["devicetree_upfile"] && $_POST["devicetree_check"]) {
        move_uploaded_file($_FILES["devicetree_upfile"]["tmp_name"], $new_devicetree_filename);
        write_string($_POST["devicetree_version"], $new_devicetree_version_filename);
    }
    if ($_FILES["rootfs_upfile"] && $_POST["rootfs_check"]) {
        move_uploaded_file($_FILES["rootfs_upfile"]["tmp_name"], $new_rootfs_filename);
        write_string($_POST["rootfs_version"], $new_rootfs_version_filename);
    }
} elseif ($_POST["restart_button"]) {

    // apply the changes if requested
    if (file_exists($new_uboot_filename)) {
	    if (file_exists($uboot_filename)) {
            unlink($uboot_filename);
        }
        rename($new_uboot_filename, $uboot_filename);
        exec("dd if=" . $uboot_filename . " of=/dev/mmcblk0p3 bs=256k seek=0");
        exec("dd if=" . $uboot_filename . " of=/dev/mmcblk0p3 bs=256k seek=1");
        exec("dd if=" . $uboot_filename . " of=/dev/mmcblk0p3 bs=256k seek=2");
        exec("dd if=" . $uboot_filename . " of=/dev/mmcblk0p3 bs=256k seek=3");
        exec("sync");
    }
    if (file_exists($new_uboot_version_filename)) {
        if (file_exists($uboot_version_filename)) {
            unlink($uboot_version_filename);
        }
        rename($new_uboot_version_filename, $uboot_version_filename);
    }
    if (file_exists($new_fpga_fabric_filename)) {
        unlink($fpga_fabric_filename);
        rename($new_fpga_fabric_filename, $fpga_fabric_filename);
    }
    if (file_exists($new_fpga_fabric_version_filename)) {
        if (file_exists($fpga_fabric_version_filename)) {
            unlink($fpga_fabric_version_filename);
        }
        rename($new_fpga_fabric_version_filename, $fpga_fabric_version_filename);
    }
    if (file_exists($new_fpga_periph_filename)) {
        unlink($fpga_periph_filename);
        rename($new_fpga_periph_filename, $fpga_periph_filename);
    }
    if (file_exists($new_fpga_periph_version_filename)) {
        if (file_exists($fpga_periph_version_filename)) {
            unlink($fpga_periph_version_filename);
        }
        rename($new_fpga_periph_version_filename, $fpga_periph_version_filename);
    }
    if (file_exists($new_devicetree_filename)) {
        unlink($devicetree_filename);
        rename($new_devicetree_filename, $devicetree_filename);
    }
    if (file_exists($new_devicetree_version_filename)) {
        if (file_exists($devicetree_version_filename)) {
            unlink($devicetree_version_filename);
        }
        rename($new_devicetree_version_filename, $devicetree_version_filename);
    }
    if (file_exists($new_kernel_filename)) {
        unlink($kernel_filename);
        rename($new_kernel_filename, $kernel_filename);
    }
    if (file_exists($new_kernel_version_filename)) {
        if (file_exists($kernel_version_filename)) {
            unlink($kernel_version_filename);
        }
        rename($new_kernel_version_filename, $kernel_version_filename);
    }
    if (file_exists($new_rootfs_filename)) {
        // TODO: add extracting the archive
        exec("tar xzf /mnt/sdcard/rootfs-update.tgz -C /");
        unlink($new_rootfs_filename);
    }    
    if (file_exists($new_rootfs_version_filename)) {
        if (file_exists($rootfs_version_filename)) {
            unlink($rootfs_version_filename);
        }
        rename($new_rootfs_version_filename, $rootfs_version_filename);
    }
}

// determine if pending updates are present
$pending_updates = file_exists($new_fpga_fabric_filename) || file_exists($new_fpga_periph_filename) ||
        file_exists($new_devicetree_filename) || file_exists($new_kernel_filename) || file_exists($new_uboot_filename) ||
        file_exists($new_rootfs_filename);
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" ".w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns=".w3.org/1999/xhtml" xmlns:mso="urn:schemas-microsoft-com:office:office" xmlns:msdt="uuid:C2F41010-65B3-11d1-A29F-00AA00C14882">
    <head>
        <title>Remote System Update: Arria 10 SoC Development Kit</title>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
        <link rel="stylesheet" media="all" type="text/css" href="../style.css" />
        <!--[if gte mso 9]><xml>
        <mso:CustomDocumentProperties>
        <mso:ContentType msdt:dt="string">Document</mso:ContentType>
        </mso:CustomDocumentProperties>
        </xml><![endif]-->
        <script>

            // deal with selecting different things to upload
            function process_change() {

                // get all the elements
                fpga_fabric_upfile = document.getElementsByName("fpga_fabric_upfile")[0];
                fpga_periph_upfile = document.getElementsByName("fpga_periph_upfile")[0];
                kernel_upfile = document.getElementsByName("kernel_upfile")[0];
                devicetree_upfile = document.getElementsByName("devicetree_upfile")[0];
                uboot_upfile = document.getElementsByName("uboot_upfile")[0];
                rootfs_upfile = document.getElementsByName("rootfs_upfile")[0];
                fpga_fabric_version = document.getElementsByName("fpga_fabric_version")[0];
                fpga_periph_version = document.getElementsByName("fpga_periph_version")[0];
                kernel_version = document.getElementsByName("kernel_version")[0];
                uboot_version = document.getElementsByName("uboot_version")[0];
                devicetree_version = document.getElementsByName("devicetree_version")[0];
                rootfs_version = document.getElementsByName("rootfs_version")[0];
                fpga_fabric_check = document.getElementsByName("fpga_fabric_check")[0];
                fpga_periph_check = document.getElementsByName("fpga_periph_check")[0];
                kernel_check = document.getElementsByName("kernel_check")[0];
                devicetree_check = document.getElementsByName("devicetree_check")[0];
                uboot_check = document.getElementsByName("uboot_check")[0];
                rootfs_check = document.getElementsByName("rootfs_check")[0];
                submit = document.getElementsByName("upload_button")[0];

                // enable the required inputs
                fpga_fabric_upfile.disabled = !fpga_fabric_check.checked;
                fpga_fabric_version.disabled = !fpga_fabric_check.checked;
                fpga_periph_upfile.disabled = !fpga_periph_check.checked;
                fpga_periph_version.disabled = !fpga_periph_check.checked;
                kernel_upfile.disabled = !kernel_check.checked;
                kernel_version.disabled = !kernel_check.checked;
                devicetree_upfile.disabled = !devicetree_check.checked;
                devicetree_version.disabled = !devicetree_check.checked;
                uboot_upfile.disabled = !uboot_check.checked;
                uboot_version.disabled = !uboot_check.checked;
                rootfs_upfile.disabled = !rootfs_check.checked;
                rootfs_version.disabled = !rootfs_check.checked;

                // set the required properties
                fpga_fabric_upfile.required = fpga_fabric_check.checked;
                fpga_fabric_version.required = fpga_fabric_check.checked;
                fpga_periph_upfile.required = fpga_periph_check.checked;
                fpga_periph_version.required = fpga_periph_check.checked;
                kernel_upfile.required = kernel_check.checked;
                kernel_version.required = kernel_check.checked;
                devicetree_upfile.required = devicetree_check.checked;
                devicetree_version.required = devicetree_check.checked;
                uboot_upfile.required = uboot_check.checked;
                uboot_version.required = uboot_check.checked;
                rootfs_upfile.required = rootfs_check.checked;
                rootfs_version.required = rootfs_check.checked;

                // enable the submit button as required
                submit.disabled = !fpga_fabric_check.checked && !fpga_periph_check.checked &&
                        !kernel_check.checked && !devicetree_check.checked && !uboot_check.checked &&
                        !rootfs_check.checked;
            }

            // confirm either apply and restart or discard
            var apply_was_pressed = false;
            function process_submit_discard_restart() {
                if (apply_was_pressed) {
                    return confirm("Are you sure you want to apply the updates and initiate a System Restart?");
                } else {
                    return confirm("Are you sure you want to discard the Pending Updates?");
                }
            }
            // confirm restart before submit
            function onclick_apply() {
                apply_was_pressed = true;
            }

            // confirm restart before submit
            function onclick_discard() {
                apply_was_pressed = false;
            }

            // validate data before submit
            function process_submit_update() {

                // get all the elements
                fpga_fabric_upfile = document.getElementsByName("fpga_fabric_upfile")[0];
                fpga_periph_upfile = document.getElementsByName("fpga_periph_upfile")[0];
                kernel_upfile = document.getElementsByName("kernel_upfile")[0];
                devicetree_upfile = document.getElementsByName("devicetree_upfile")[0];
                uboot_upfile = document.getElementsByName("uboot_upfile")[0];
                rootfs_upfile = document.getElementsByName("rootfs_upfile")[0];
                fpga_fabric_version = document.getElementsByName("fpga_fabric_version")[0];
                fpga_periph_version = document.getElementsByName("fpga_periph_version")[0];
                kernel_version = document.getElementsByName("kernel_version")[0];
                devicetree_version = document.getElementsByName("devicetree_version")[0];
                rootfs_version = document.getElementsByName("rootfs_version")[0];
                uboot_version = document.getElementsByName("uboot_version")[0];
                fpga_fabric_check = document.getElementsByName("fpga_fabric_check")[0];
                fpga_periph_check = document.getElementsByName("fpga_periph_check")[0];
                kernel_check = document.getElementsByName("kernel_check")[0];
                devicetree_check = document.getElementsByName("devicetree_check")[0];
                uboot_check = document.getElementsByName("uboot_check")[0];
                rootfs_check = document.getElementsByName("rootfs_check")[0];
                submit = document.getElementsByName("upload_button")[0];

                // check fpga core file
                if (fpga_fabric_check.checked) {

                    // check file extension
                    if (!/^.*\.rbf$/.test(fpga_fabric_upfile.value)) {
                        alert("Invalid FPGA Fabric filename: '" + fpga_fabric_upfile.value + "'!\n" +
                                "File needs to have .rbf extension.");
                        return false;
                    }


                    // check file size            
                    fsize = fpga_fabric_upfile.files[0].size / 1000 / 1000;
                    if ((fsize < 5) || (fsize > 75)) {
                        alert("Invalid FPGA Fabric file: '" + fpga_fabric_upfile.value + "'!\n" +
                                "File size is " + fsize + "MB and needs to be between 5MB and 75MB.");
                        return false;
                    }
                }

                // check fpga peripheral file
                if (fpga_periph_check.checked) {

                    // check file extension
                    if (!/^.*\.rbf$/.test(fpga_periph_upfile.value)) {
                        alert("Invalid FPGA Fabric filename: '" + fpga_periph_upfile.value + "'!\n" +
                                "File needs to have .rbf extension.");
                        return false;
                    }

                    // check file size            
                    fsize = fpga_periph_upfile.files[0].size / 1000;
                    if ((fsize < 100) || (fsize > 750)) {
                        alert("Invalid FPGA Peripheral file: '" + fpga_periph_upfile.value + "'!\n" +
                                "File size is " + fsize + "KB and needs to be between 100KB and 750KB.");
                        return false;
                    }
                }

                // check kernel file
                if (kernel_check.checked) {

                    // check file size
                    fsize = kernel_upfile.files[0].size / 1000 / 1000;
                    if ((fsize < 1) || (fsize > 10)) {
                        alert("Invalid Kernel file: '" + kernel_upfile.value + "'!\n" +
                                "File size is " + fsize + "MB and needs to be between 1MB and 10MB.");
                        return false;
                    }
                }

                // check the devicetreee file
                if (devicetree_check.checked) {

                    // check file extension                        
                    if (!/^.*\.dtb$/.test(devicetree_upfile.value)) {
                        alert("Invalid Devicetree filename: '" + devicetree_upfile.value + "'!\n" +
                                "File needs to have .dtb extension.");
                        return false;
                    }

                    // check file size
                    fsize = devicetree_upfile.files[0].size / 1000;
                    if ((fsize < 10) || (fsize > 200)) {
                        alert("Invalid Devicetree file: '" + devicetree_upfile.value + "'!\n" +
                                "File is " + fsize + "KB and needs to be between 10KB and 200KB.");
                        return false;
                    }
                }

                // check the uboot file
                if (uboot_check.checked) {

                    // check file size
                    fsize = uboot_upfile.files[0].size;
                    if (fsize != (1024 * 1024)) {
                        alert("Invalid U-Boot file: '" + uboot_upfile.value + "'!\n" +
                                "File size is " + fsize + " bytes and needs to be 1MB.");
                        return false;
                    }
                }

                // check rootfs file
                if (rootfs_check.checked) {

                    // check file extension
                    if (!/^.*\.tgz$/.test(rootfs_upfile.value) && !/^.*\.tar\.gz$/.test(rootfs_upfile.value)) {
                        alert("Invalid Root Filesystem Update filename: '" + rootfs_upfile.value + "'!\n" +
                                "File needs to have .tgz or .tar.gz extension.");
                        return false;
                    }
                }

                // success
                return true;
            }

            var c = 0;

            function timeout_function() {
                document.getElementById("countdown_span").innerHTML = c;
                if (c != 0) {
                    c = c - 1;
                    setTimeout(function () {
                        timeout_function()
                    }, 1000);
                } else {
                    document.location.href = "/cgi-bin/remote_system_update.php"
                }
            }

            function start_timeout() {
                c = 40;
                timeout_function();
            }

            function onclick_toggle_system_details()
            {
                $system_details = document.getElementById("system_details");
                $system_details.hidden = !$system_details.hidden;
                $toggle_system_details = document.getElementById("toggle_system_details");
                $toggle_system_details.innerHTML = $system_details.hidden ? "show" : "hide";
                return false;
            }

        </script>
    </head>
    <body class="body-container">
        <div class="bup-header">
            <img src="../altera-logo.gif" alt="Altera Logo" style="float:left; padding:15px 0px 15px 10px;"/>
            <div class="bup-header-right"><span>Remote System Update</span><br/>
                Arria 10 SoC Development Kit
            </div>
        </div>
        <div class="bup-content">

            <div class="bup-form">
                <span><strong><h1>Overview</h1></strong><br/>
                </span>
                <p>This Remote System Update web page is being served by the web server application running on the Hard Processor System (HPS) of your development board. You can use this web page to update the software and hardware running on your board. </p>
            </div>
            <div class="bup-links">
                <h4>Developer Resources</h4>
                <ul>
                    <li><a href="http://www.altera.com/soc-hw-resources.html" target="_blank">Hardware Developers</a></li> 
                    <li><a href="http://www.altera.com/soc-sw-resources.html" target="_blank">Software Developers</a></li>
                </ul>
                <h4>Navigation</h4>
                <ul>
                    <li><a href="/">Back to Home Page</a></li> 
                </ul>
            </div>            
<?php if ($_POST["restart_button"]) { ?>    

                <div id="interactive" class="bup-form">
                    <hr style="border: 1px solid; color:#06c" /><br />
                    <span><strong><h1>System Restart In Progress</h1></strong><br/>
                    </span>                  
                    <span>The system is currently being restarted. This page will automatically update in 
                        <span id="countdown_span"  style="color:red"></span> seconds.
                    </span>
                </div>

                <script>start_timeout();</script>
<?php } else { ?>

                <div id="interactive" class="bup-form">
                    <hr style="border: 1px solid; color:#06c" /><br />
                    <span><strong><h1>Current Hardware and Software</h1></strong><br/>
                    </span>                
                    <span>The following table presents the currently running software and hardware items, along with file name, file size and version information.
                        <br /><br />
                    </span>                
                    <table cellpadding="2" cellspacing="2" style="margin-top:0px; margin-left:0px; font-family: Arial; font-size: 11pt">
                        <tr>
                            <th>Item</th>
                            <th>File</th>
                            <th>Size</th>
                            <th>Version</th>
                        </tr>
                        <tr>
                            <td>Combined U-Boot Image</td>
                            <td>n/a</td>
                            <td><!--?php echo filesize($uboot_filename); ?-->1048576</td>
                            <td align="center"><?php echo read_string($uboot_version_filename); ?></td>
                        </tr>                        
                        <tr>
                            <td>FPGA Fabric Configuration</td>
                            <td>ghrd_10as066n2.fabric.rbf</td>
                            <td><?php echo filesize($fpga_fabric_filename); ?></td>
                            <td align="center"><?php echo read_string($fpga_fabric_version_filename); ?></td>
                        </tr>
                        <tr>
                            <td>FPGA Peripheral Configuration</td>
                            <td>ghrd_10as066n2.periph.rbf</td>
                            <td><?php echo filesize($fpga_periph_filename); ?></td>
                            <td align="center"><?php echo read_string($fpga_periph_version_filename); ?></td>
                        </tr>
                        <tr>
                            <td>Linux Kernel Image</td>
                            <td>zImage</td>
                            <td><?php echo filesize($kernel_filename); ?></td>
                            <td align="center"><?php echo read_string($kernel_version_filename); ?></td>
                        </tr>
                        <tr>
                            <td>Linux Device Tree Image</td>
                            <td>socfpga_arria10_socdk.dtb</td>
                            <td><?php echo filesize($devicetree_filename); ?></td>
                            <td align="center"><?php echo read_string($devicetree_version_filename); ?></td>
                        </tr>
                        <tr>
                            <td>Root Filesystem</td>
                            <td>n/a</td>
                            <td>n/a</td>
                            <td align="center"><?php echo read_string($rootfs_version_filename); ?></td>
                        </tr>                        
                    </table>
                    <br/>                    
                    <span><strong>Additional System Details</strong> (<a id="toggle_system_details" href="#" onClick="onclick_toggle_system_details();">show</a>)</span>
                    <span style="font-size:90%" id="system_details" hidden="true">                        
                        <hr style="border: 1px dotted"/>
    <?php
    $sysid_path = exec("find /sys/ -type d -name sysid");
    $sysid_id = exec("cat " . $sysid_path . "/id");
    $sysid_timestamp = exec("cat " . $sysid_path . "/timestamp");
    $linux_kernel_version = exec("uname -a");
    $uboot_version = exec("dd if=/dev/mmcblk0p3 bs=256k count=1 2>/dev/null | strings | grep \"U-Boot\" | grep \"(\" | grep \")\" | grep \"-\" | grep \":\"");
    exec("ls /lib/modules", $kernel_modules);
    echo "<b>sysid id</b>: " . $sysid_id;
    echo "<br/><b>sysid timestamp</b>: " . $sysid_timestamp;
    echo "<br/><b>kernel version</b>: " . $linux_kernel_version;
    echo "<br/><b>uboot version</b>:" . $uboot_version;
    echo "<br/><b>installed kernel modules</b>:";
    foreach ($kernel_modules as &$module) {
        echo "    " . $module;
    }
    ?>
                        <br/>
                    </span>                
                </div>

                <div id="interactive" class="bup-form">
                    <form action="/cgi-bin/remote_system_update.php#pending" method="post" enctype="multipart/form-data" onSubmit="return process_submit_update();">
                        <hr style="border: 1px solid; color:#06c" /><br />
                        <span><strong><h1>Upload Hardware and Software Updates</h1></strong><br/>
                        </span>                
                        <span>Use the following controls to upload a new version for the desired hardware or software item. 
                            Check the corresponding <b>Update</b> checkbox to update a certain item, then select the new file and type in the new item version.
                            When done, press the <b>Upload</b> button to submit your changes.
                            <br /> <br/>
                        </span>
                        <table cellpadding="2" cellspacing="2" style="margin-top:0px; margin-left:0px; font-family: Arial; font-size: 11pt">
                            <tr><th>Update</th><th>Item</th><th>File</th><th>Version</th></tr>
                            <tr>
                                <td align="center"><input type="checkbox" name="uboot_check" onchange="process_change()" /></td>
                                <td>Combined U-Boot Image</td>
                                <td><input type="file" name="uboot_upfile" onchange="process_change()"/></td>
                                <td><input type="text" name="uboot_version" style="text-align: right;" size="4"  value="" onchange="process_change()"/></td>
                            </tr>                              
                            <tr>
                                <td align="center"><input type="checkbox" name="fpga_fabric_check" onchange="process_change()" /></td>
                                <td>FPGA Fabric Configuration</td>
                                <td><input type="file" name="fpga_fabric_upfile" onchange="process_change()"/></td>
                                <td><input type="text" name="fpga_fabric_version" style="text-align: right;" size="4"  value="" onchange="process_change()"/></td>
                            </tr>                            
                            <tr>
                                <td align="center"><input type="checkbox" name="fpga_periph_check" onchange="process_change()"/></td>
                                <td>FPGA Peripheral Configuration</td>
                                <td><input type="file" name="fpga_periph_upfile" onchange="process_change()"/></td>
                                <td><input type="text" style="text-align: right;" size="4" name="fpga_periph_version" value="" onchange="process_change()"/></td>                            
                            </tr>
                            <tr>
                                <td align="center"><input type="checkbox" name="kernel_check" onchange="process_change()" /></td>
                                <td>Linux Kernel Image</td>
                                <td><input type="file" name="kernel_upfile" onchange="process_change()"/></td>
                                <td><input type="text" onchange="process_change()" style="text-align: right;" size="4" name="kernel_version" value=""/></td>                            
                            </tr>
                            <tr>
                                <td align="center"><input type="checkbox" name="devicetree_check" onchange="process_change()" /></td>
                                <td>Linux Device Tree Image</td>
                                <td><input type="file" name="devicetree_upfile" onchange="process_change()"/></td>
                                <td><input type="text" name="devicetree_version" style="text-align: right;" size="4" value="" onchange="process_change()"/></td>                            
                            </tr>
                            <tr>
                                <td align="center"><input type="checkbox" name="rootfs_check" onchange="process_change()" /></td>
                                <td>Root Filesystem Update <span style="font-size:90%"><sup>*</sup></span></td>
                                <td><input type="file" name="rootfs_upfile" onchange="process_change()"/></td>
                                <td><input type="text" name="rootfs_version" style="text-align: right;" size="4" value="" onchange="process_change()"/></td>                            
                            </tr>
                        </table>                        
                        <span style="font-size:90%"><sup>* </sup>The rootfs update is a .tgz archive to be extracted on top of the root filesystem. </span>
                        <br />
                        <br />
                        <input type="submit" name="upload_button" value="Upload"/>
                        <div><br/>Note that the updates will not be applied until pressing the <b>Apply & Restart</b> button in the following section.</div>
                    </form>
                    <script>process_change();</script>
                </div>

                <div id="pending" class="bup-form">                    
                    <hr style="border: 1px solid; color:#06c" /><br />
                    <span><strong><h1>Pending Hardware and Software Updates</h1></strong><br/>
                    </span>             
    <?php if ($pending_updates) { ?>
                        <span>The following presents the software and hardware items that were uploaded but not yet applied. Press <b>Apply & Restart</b> to apply the updates and restart the system. Press <b>Discard</b> to discard the updates.
                            <br /><br />
                        </span>             
                        <table cellpadding="2" cellspacing="2" style="margin-top:0px; margin-left:0px; font-family: Arial; font-size: 11pt;">
                            <tr>
                                <th>Item</th>
                                <th>File</th>
                                <th>Size</th>
                                <th>Version</th>
                            </tr>
        <?php if (file_exists($new_uboot_filename)) { ?>
                                <tr>
                                    <td>Combined U-Boot Image</td>
                                    <td>uboot</td>
                                    <td><?php echo filesize($new_uboot_filename); ?></td>
                                    <td align="center"><?php echo read_string($new_uboot_version_filename); ?></td>
                                </tr>
        <?php } ?>                            
                            <?php if (file_exists($new_fpga_fabric_filename)) { ?>
                                <tr>
                                    <td>FPGA Fabric Configuration</td>
                                    <td>ghrd_10as066n2.fabric.rbf</td>
                                    <td><?php echo filesize($new_fpga_fabric_filename); ?></td>
                                    <td align="center"><?php echo read_string($new_fpga_fabric_version_filename); ?></td>
                                </tr>
        <?php } ?>
                            <?php if (file_exists($new_fpga_periph_filename)) { ?>
                                <tr>
                                    <td>FPGA Peripheral Configuration</td>
                                    <td>ghrd_10as066n2.periph.rbf</td>
                                    <td><?php echo filesize($new_fpga_periph_filename); ?></td>
                                    <td align="center"><?php echo read_string($new_fpga_periph_version_filename); ?></td>
                                </tr>
        <?php } ?>
                            <?php if (file_exists($new_kernel_filename)) { ?>
                                <tr>
                                    <td>Linux Kernel Image</td>
                                    <td>zImage</td>
                                    <td><?php echo filesize($new_kernel_filename); ?></td>
                                    <td align="center"><?php echo read_string($new_kernel_version_filename); ?></td>
                                </tr>
        <?php } ?>
                            <?php if (file_exists($new_devicetree_filename)) { ?>
                                <tr>
                                    <td>Linux Device Tree Image</td>
                                    <td>socfpga_arria10_socdk.dtb</td>
                                    <td><?php echo filesize($new_devicetree_filename); ?></td>
                                    <td align="center"><?php echo read_string($new_devicetree_version_filename); ?></td>
                                </tr>
        <?php } ?>
                            <?php if (file_exists($new_rootfs_filename)) { ?>
                                <tr>
                                    <td>Root Filesystem Update</td>
                                    <td>rootfs-update.tgz</td>
                                    <td><?php echo filesize($new_rootfs_filename); ?></td>
                                    <td align="center"><?php echo read_string($new_rootfs_version_filename); ?></td>
                                </tr>
        <?php } ?>                            
                        </table>                        
                        <br />
                        <form action="/cgi-bin/remote_system_update.php" method="post" enctype="multipart/form-data" onSubmit="return process_submit_discard_restart();">
                            <input type="submit" name="restart_button" value="Apply & Restart" onClick="onclick_apply();" />
                            <input type="submit" name="discard_button" value="Discard" onClick="onclick_discard();" />                            
                        </form>
    <?php } else { ?>
                        <span>No updates are currently pending. Use the section above to upload new items.</span> 
                        <br /><br />
                        <input type="submit" name="restart_button" value="Apply & Restart" disabled="false"/>
                        <input type="submit" name="discard_button" value="Discard" disabled="true"/>   
    <?php } ?>
                </div>
                <?php } ?>

        </div>
        <div class="footer-gutter"></div>
        <div class="footer-container-blur">
            <div class="footer-container-shadow">
                <div id="footer" class="footer-container">
                    <div id="footerCopyright" class="footer-copyright">
                        <p align="center" style="width:900px; font-size:9px;">Copyright &copy; 1995-2015 Altera Corporation. All Rights Reserved.<br/>
                            ALTERA, ARRIA, CYCLONE, HARDCOPY, MAX, MEGACORE, NIOS, QUARTUS &amp; STRATIX are Reg. U.S. Pat. &amp; Tm. Off. and Altera marks in and outside the U.S.</p>
                    </div>
                </div>
            </div>
        </div>
        <!--?php
        echo "<b>POST</b>: ";
        print_r($_POST);
        echo "<br/>";
        echo "<b>FILES</b>: ";
        print_r($_FILES);
        echo "<br/>";
        system("uname -a");
        phpinfo();
        ?-->
    </body>
</html>
<?php
if ($_POST["restart_button"]) {
    # initiate system restart
    flush();
    exec("sync");
    exec("umount /mnt/sdcard");
    sleep(1);
    exec("reboot");
}
?>  
